package www.terasic.com.tw.android.SmartCar_Remote;





import java.util.Date;

import android.content.Context;
import android.graphics.BlurMaskFilter;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.RectF;
import android.util.AttributeSet;
import android.util.Log;
import android.view.View;

public class Arcs extends View {   
    public Arcs(Context context) {
		super(context);
		// TODO Auto-generated constructor stub
		InitRPMView();
	}
	public Arcs(Context context, AttributeSet attrs) {
		super(context, attrs);
		InitRPMView();
	}

	public Arcs(Context context, AttributeSet attrs, int defStyle) {
		super(context, attrs, defStyle);
		InitRPMView();
	}
	
	private Paint mArcPaint;   
    private Paint mArcBGPaint; 
   
    private RectF mOval;   
    private float mSweep = 0;   
    private int mSpeedMax = 100; 
    private int mThreshold = 50; 
    public float mIncSpeedValue = 0; 
    public float mCurrentSpeedValue = 0;  
    private float mCenterX;   
    private float mCenterY;   
    private float mSpeedArcWidth=25;   
    
    private final float SPEED_VALUE_INC = 1;  



    private void InitRPMView() {
    	setFocusable(true);
        mArcPaint = new Paint(Paint.ANTI_ALIAS_FLAG); 
        mArcPaint.setStyle(Paint.Style.STROKE); 
        mArcPaint.setStrokeWidth(mSpeedArcWidth); 
        mArcPaint.setColor(0xff81ccd6); 
        BlurMaskFilter mBlur = new BlurMaskFilter(8, BlurMaskFilter.Blur.INNER); 
        mArcPaint.setMaskFilter(mBlur); 
        
        mArcBGPaint = new Paint(Paint.ANTI_ALIAS_FLAG); 
        mArcBGPaint.setStyle(Paint.Style.STROKE); 
        mArcBGPaint.setStrokeWidth(mSpeedArcWidth+8); 
        mArcBGPaint.setColor(0xff171717); 
         
        BlurMaskFilter mBGBlur = new BlurMaskFilter(8, BlurMaskFilter.Blur.INNER); 
        mArcBGPaint.setMaskFilter(mBGBlur);  
        

        

   }


  
  	protected void onSizeChanged(int w, int h, int ow, int oh) { 
        super.onSizeChanged(w, h, ow, oh); 
        Log.i("onSizeChanged w", w+""); 
        Log.i("onSizeChanged h", h+""); 
        mCenterX = w * 0.5f;  // remember the center of the screen 
        mCenterY = h - mSpeedArcWidth; 
        mOval = new RectF(mCenterX - mCenterY, mSpeedArcWidth, mCenterX + mCenterY, mCenterY * 2); 
    } 
  	@Override   
    protected void onDraw(Canvas canvas) {  
        drawSpeed(canvas);  
        calcSpeed();  
    }  
  
  	private void drawSpeed(Canvas canvas) {  
        canvas.drawArc(mOval, 179, 181, false, mArcBGPaint);  
        mSweep = (float) mIncSpeedValue / mSpeedMax * 180; 
        mArcPaint.setColor((int) (0xFFFFFF00 - ((mIncSpeedValue*512) )));
        canvas.drawArc(mOval, 180, mSweep, false, mArcPaint);  
        
    }  
  
  	public void calcSpeed() {  
        if (mIncSpeedValue < mCurrentSpeedValue) {  
            mIncSpeedValue += SPEED_VALUE_INC;  
            if (mIncSpeedValue > mCurrentSpeedValue) {  
                mIncSpeedValue = mCurrentSpeedValue;  
            }  
            invalidate();  
        }  
        else if (mIncSpeedValue > mCurrentSpeedValue) {  
            mIncSpeedValue -= SPEED_VALUE_INC;  
            if (mIncSpeedValue < mCurrentSpeedValue) {  
                mIncSpeedValue = mCurrentSpeedValue;  
            }  
            invalidate();  
        }  
    }  
}