module MANUAL_START  (
  input  CLK_50 , 
  input  KEY ,
  
  input  RESET_N , 
  output reg TRACK, 
  output reg READY, 
  
  output reg PLAY
) ;
//-- KEY[0] Trigger --
parameter SEC_3  = 50000000*2 ; 
parameter SEC_5  = 50000000*5 ; 
parameter SEC    = 25000000; 

reg        rK ; 
reg [31:0] TIMER ;  
reg [7:0]  ST ; 
always @( negedge RESET_N or posedge  CLK_50 )  begin 
if (!RESET_N) begin 
  ST    <=0;
  rK    <=KEY ;
  TIMER <=0 ;
  TRACK <=0; 
  PLAY  <=0;  
  READY <=0;
end
else  begin 
     rK <=KEY ;
case (ST) 	  
0: begin 
        if  ( (  rK &  !KEY ) | (  !rK &  KEY )  ) TIMER <=0 ;
	else if  ( TIMER > SEC_3 )  begin  ST<=1 ; TRACK <=1;  TIMER <=0 ; READY <=1; end 
	else if  ( ( TIMER < SEC_5 ) & (!KEY ) )   TIMER <= TIMER +1 ;
   end 	
	
1: begin 
	 if (TIMER < SEC_3 ) TIMER <= TIMER +1 ;
	 else begin ST<=2 ;  PLAY  <=1;  end 
   end 	
	
2: begin 
        if ( rK &  !KEY ) ST <=3 ;
   end 	
	
3: begin 
        if ( !rK &  KEY)  begin 
		     ST <=4 ;
			  TIMER <=0 ;
			  TRACK <=0; 
			  PLAY  <=0;
		  end 	
   end 	
	
4: begin 	
	if ( TIMER < SEC )  TIMER <= TIMER +1  ;
	else  begin READY <=0; ST <=0 ; end 
	end 
	
endcase 
	
end
end 

endmodule 
 	